;
;	for GOGO-no-coda
;	Copyright (C) 1999, 2000, 2001
;

%include "nasm.cfg"

	segment_data
	align	32
Q_0_0_0_0	dd		0, 0, 0, 0
Q_ABS		dd		0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF
f0p4054		dd		0.4054
f0p5946		dd		0.5946

	segment_text

;void quantize_xrpow_ISO( float *xr, int *ix, float *istepPtr );

;	shigeo
;	2001/07/20 Init. version
;	1360clk@PIII-700 ̂Athlon̔{?(^^;

proc	quantize_xrpow_ISO_SSE
%assign _P (4*0)
		mov			eax, [esp+_P+12]
		movss		xm0, [eax]				;istep
		mov			eax, [esp+_P+4]			;xr
		mov			edx, [esp+_P+8]			;ix
		movss		xm1, [f0p4054]
		mov			ecx, -576
		shufps		xm0, xm0, 0				;xm0 = [istep]
		shufps		xm1, xm1, 0				;xm1 = [0.4054]
.lp:
		movaps		xm2, [eax+4* 0]
		movaps		xm3, [eax+4* 4]
		movaps		xm4, [eax+4* 8]
		movaps		xm5, [eax+4*12]
		add			eax, byte 64
		mulps		xm2, xm0
		mulps		xm3, xm0
		mulps		xm4, xm0
		mulps		xm5, xm0
		addps		xm2, xm1
		addps		xm3, xm1
		addps		xm4, xm1
		addps		xm5, xm1
		cvttps2pi	mm0, xm2
		movhlps		xm2, xm2
		cvttps2pi	mm2, xm3
		movhlps		xm3, xm3
		cvttps2pi	mm4, xm4
		movhlps		xm4, xm4
		cvttps2pi	mm6, xm5
		movhlps		xm5, xm5
		cvttps2pi	mm1, xm2
		cvttps2pi	mm3, xm3
		cvttps2pi	mm5, xm4
		cvttps2pi	mm7, xm5
		add			ecx, byte 16
		movq		[edx+4* 0], mm0
		movq		[edx+4* 2], mm1
		movq		[edx+4* 4], mm2
		movq		[edx+4* 6], mm3
		movq		[edx+4* 8], mm4
		movq		[edx+4*10], mm5
		movq		[edx+4*12], mm6
		movq		[edx+4*14], mm7
		lea			edx, [edx + 64]
		jnz			.lp
.exit:
		emms
		ret

;	cf.
;	quantize_xrpow_ISO with TAKEHIRO_IEEE754_HACK(3900clk@PIII)

;	by shigeo
;	Init. version 2400clk@PIII

proc	quantize_xrpow_ISO_FPU
%assign _P (4*0)
		mov			eax, [esp+_P+12]		; istepPtr
		fld			dword [eax]				; istep
		fld			dword [f0p4054]			; 0.4054, istep
		mov			eax, [esp+_P+4]			; xr
		mov			edx, [esp+_P+8]			; ix
		add			eax, 576 * 4
		add			edx, 576 * 4
		mov			ecx, -576

		;؂̂ă[h
%if 0
		push		eax
		fnstcw		word [esp]
		or			word [esp], 0x0C00
		fldcw		word [esp]
%else
		push		dword 0xE72				; ߂ǂł傤
		fldcw		word [esp]
%endif
%if 1
.lp:	;2400clk@PIII
		fld			dword [eax+ecx*4]		; xr, 0.4054, istep
		fld			dword [eax+ecx*4+4]
		fld			dword [eax+ecx*4+8]
		fld			dword [eax+ecx*4+12]	; 3, 2, 1, 0, 0.4054, istep
		fmul		st0, st5
		fxch		st1						; 2, 3x, 1, 0
		fmul		st0, st5
		fxch		st2						; 1, 3x, 2x, 0
		fmul		st0, st5
		fxch		st3						; 0, 3x, 2x, 1x
		fmul		st0, st5
		fxch		st1						; 3x, 0x, 2x, 1x
		fadd		st0, st4
		fxch		st2						; 2x, 0x, 3x+, 1x
		fadd		st0, st4
		fxch		st3						; 1x, 0x, 3x+, 2x+
		fadd		st0, st4
		fxch		st1						; 0x, 1x+, 3x+, 2x+
		fadd		st0, st4
		fxch		st2						; 3x+, 1x+, 0x+, 2x+
		fistp		dword [edx+ecx*4+12]
		fistp		dword [edx+ecx*4+4]
		fistp		dword [edx+ecx*4]
		fistp		dword [edx+ecx*4+8]
		add			ecx, 4
		jnz			.lp
%else
.lp:	;3000clk@PIII
		fld			dword [eax+ecx*4]		; xr, 0.4054, istep
		fmul		st0, st2
		fadd		st0, st1
		fistp		dword [edx+ecx*4]
		inc			ecx
		jnz			.lp
%endif
.exit:
		fcompp
		;ɖ߂
%if 0
		and			word [esp], ~0x0C00
		fldcw		word [esp]
%else
		mov			dword [esp], 0x272
		fldcw		word [esp]
%endif
		pop			eax

		ret


;	kei 2001/07/18 Init. version 740clk@K7-500

proc	quantize_xrpow_ISO_3DN
%assign _P (4*0)
		femms
		mov			edx, [esp+_P+12]		;istepPtr
		mov			eax, [esp+_P+4]			;xr
		mov			ecx, -576
		movd		mm7, [edx]				;istep
		movd		mm6, [f0p4054]
		mov			edx, [esp+_P+8]			;ix
		add			eax, 576 * 4
		punpckldq	mm7, mm7
		punpckldq	mm6, mm6
		add			edx, 576 * 4
.lp:
		movq		mm0, [eax+ecx*4+ 0]
		movq		mm1, [eax+ecx*4+ 8]
		movq		mm2, [eax+ecx*4+16]
		movq		mm3, [eax+ecx*4+24]
		movq		mm4, [eax+ecx*4+32]
		movq		mm5, [eax+ecx*4+40]
		pfmul		mm0, mm7
		pfmul		mm1, mm7
		pfmul		mm2, mm7
		pfmul		mm3, mm7
		pfmul		mm4, mm7
		pfmul		mm5, mm7
		add			ecx, byte 12
		pfadd		mm0, mm6
		pfadd		mm1, mm6
		pfadd		mm2, mm6
		pfadd		mm3, mm6
		pfadd		mm4, mm6
		pfadd		mm5, mm6
		pf2id		mm0, mm0
		pf2id		mm1, mm1
		pf2id		mm2, mm2
		pf2id		mm3, mm3
		pf2id		mm4, mm4
		pf2id		mm5, mm5
		movq		[edx+ecx*4-12*4+ 0], mm0
		movq		[edx+ecx*4-12*4+ 8], mm1
		movq		[edx+ecx*4-12*4+16], mm2
		movq		[edx+ecx*4-12*4+24], mm3
		movq		[edx+ecx*4-12*4+32], mm4
		movq		[edx+ecx*4-12*4+40], mm5
		jnz			near .lp
.exit:
		femms
		ret


;void pow075(
;	float xr[576],
;	float xrpow[576],
;	float *psum,
;	float *pmax,
;	uint32 *xr_sign);

;	2001/08/11
;	Init. version by shigeo
;	14.6Kclk@PIII
;	TODO: ߎvZɂ郋[g̍

proc	pow075_SSE
		push		ebx
%assign _P 4*1
		mov			eax, [esp+_P+4]			; eax = xr
		mov			ebx, [esp+_P+8]			; ebx = xrpow
		mov			edx, [esp+_P+20]		; edx = xr_sign
		mov			ecx, -576
		xorps		xm2, xm2				; xm2 = srpow_sum
		xorps		xm3, xm3				; xm3 = srpow_sum'
		xorps		xm4, xm4				; xm4 = xrpow_max
		xorps		xm5, xm5				; xm5 = xrpow_max'
		lea			eax, [eax + 576*4]
		lea			ebx, [ebx + 576*4]
		lea			edx, [edx + 576*4]
.lp:
		movaps		xm0, [eax+ecx*4+ 0]
		movaps		xm1, [eax+ecx*4+16]
		movaps		xm6, xm0
		movaps		xm7, xm1
		andps		xm0, [Q_ABS]			; xm0 = |xr|
		andps		xm1, [Q_ABS]
		cmpltps		xm6, [Q_0_0_0_0]		; xm6 = (xr<0) ? -1 : 0
		cmpltps		xm7, [Q_0_0_0_0]
		movaps		[edx+ecx*4+ 0], xm6
		movaps		[edx+ecx*4+16], xm7
%if 1	;x???
		sqrtps		xm6, xm0
		addps		xm2, xm0				; srpow_sum += |xr|
		movaps		[eax+ecx*4+ 0], xm0
		sqrtps		xm7, xm1
		addps		xm3, xm1
		movaps		[eax+ecx*4+16], xm1
		mulps		xm0, xm6
		mulps		xm1, xm7
		sqrtps		xm6, xm0
		sqrtps		xm7, xm1
%else
		rsqrtps		xm6, xm0				; xr^-0.5
		addps		xm2, xm0				; srpow_sum += |xr|
		movaps		[eax+ecx*4+ 0], xm0
		rsqrtps		xm7, xm1
		addps		xm3, xm1
		movaps		[eax+ecx*4+16], xm1
		mulps		xm0, xm6				; xr^0.5
		mulps		xm1, xm7
		rsqrtps		xm6, xm6				; xr^0.25
		rsqrtps		xm7, xm7
		mulps		xm0, xm6				; xr^0.75
		mulps		xm1, xm7

		; xr == 0̂Ƃ̏(by sakai)
		movaps		xm6, xm0
		movaps		xm7, xm1
		cmpps		xm0, xm0, 0				; if( xr == 0 )
		cmpps		xm1, xm1, 0
		andps		xm6, xm0				; then 0
		andps		xm7, xm1
%endif
		maxps		xm4, xm6
		maxps		xm5, xm7
		movaps		[ebx+ecx*4+ 0], xm6		; xrpow
		movaps		[ebx+ecx*4+16], xm7
		add			ecx, byte 8
		jnz			.lp

		maxps		xm4, xm5
		addps		xm2, xm3

		movhlps		xm5, xm4				; [*:*: 3: 2]
		movhlps		xm3, xm2
		maxps		xm5, xm4				; [*:*:31:20]
		addps		xm3, xm2
		unpcklps	xm0, xm5				; [*:*:20: *]
		unpcklps	xm1, xm3
		maxps		xm5, xm0				; [*:*:max:*]
		addps		xm3, xm1				; [*:*:sum:*]
		mov			eax, [esp+_P+12]		; psum
		mov			edx, [esp+_P+16]		; pmax
		shufps		xm5, xm5, PACK(1,1,1,1)	; max
		shufps		xm3, xm3, PACK(1,1,1,1)	; sum
		movss		[eax], xm3
		movss		[edx], xm5
.exit:
		pop			ebx
		ret

		end
